<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerManagementPendingDsk ArrayType
 * @subpackage Arrays
 */
class ArrayOfCustomerManagementPendingDsk extends AbstractStructArrayBase
{
    /**
     * The CustomerManagementPendingDsk
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\CustomerManagementPendingDsk[]
     */
    public $CustomerManagementPendingDsk;
    /**
     * Constructor method for ArrayOfCustomerManagementPendingDsk
     * @uses ArrayOfCustomerManagementPendingDsk::setCustomerManagementPendingDsk()
     * @param \CustomerManagement\StructType\CustomerManagementPendingDsk[] $customerManagementPendingDsk
     */
    public function __construct(array $customerManagementPendingDsk = array())
    {
        $this
            ->setCustomerManagementPendingDsk($customerManagementPendingDsk);
    }
    /**
     * Get CustomerManagementPendingDsk value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\CustomerManagementPendingDsk[]|null
     */
    public function getCustomerManagementPendingDsk()
    {
        return isset($this->CustomerManagementPendingDsk) ? $this->CustomerManagementPendingDsk : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerManagementPendingDsk method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerManagementPendingDsk method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerManagementPendingDskForArrayConstraintsFromSetCustomerManagementPendingDsk(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerManagementPendingDskCustomerManagementPendingDskItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerManagementPendingDskCustomerManagementPendingDskItem instanceof \CustomerManagement\StructType\CustomerManagementPendingDsk) {
                $invalidValues[] = is_object($arrayOfCustomerManagementPendingDskCustomerManagementPendingDskItem) ? get_class($arrayOfCustomerManagementPendingDskCustomerManagementPendingDskItem) : sprintf('%s(%s)', gettype($arrayOfCustomerManagementPendingDskCustomerManagementPendingDskItem), var_export($arrayOfCustomerManagementPendingDskCustomerManagementPendingDskItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomerManagementPendingDsk property can only contain items of type \CustomerManagement\StructType\CustomerManagementPendingDsk, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerManagementPendingDsk value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\CustomerManagementPendingDsk[] $customerManagementPendingDsk
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerManagementPendingDsk
     */
    public function setCustomerManagementPendingDsk(array $customerManagementPendingDsk = array())
    {
        // validation for constraint: array
        if ('' !== ($customerManagementPendingDskArrayErrorMessage = self::validateCustomerManagementPendingDskForArrayConstraintsFromSetCustomerManagementPendingDsk($customerManagementPendingDsk))) {
            throw new \InvalidArgumentException($customerManagementPendingDskArrayErrorMessage, __LINE__);
        }
        if (is_null($customerManagementPendingDsk) || (is_array($customerManagementPendingDsk) && empty($customerManagementPendingDsk))) {
            unset($this->CustomerManagementPendingDsk);
        } else {
            $this->CustomerManagementPendingDsk = $customerManagementPendingDsk;
        }
        return $this;
    }
    /**
     * Add item to CustomerManagementPendingDsk value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\CustomerManagementPendingDsk $item
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerManagementPendingDsk
     */
    public function addToCustomerManagementPendingDsk(\CustomerManagement\StructType\CustomerManagementPendingDsk $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\CustomerManagementPendingDsk) {
            throw new \InvalidArgumentException(sprintf('The CustomerManagementPendingDsk property can only contain items of type \CustomerManagement\StructType\CustomerManagementPendingDsk, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomerManagementPendingDsk[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\CustomerManagementPendingDsk|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\CustomerManagementPendingDsk|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\CustomerManagementPendingDsk|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\CustomerManagementPendingDsk|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\CustomerManagementPendingDsk|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerManagementPendingDsk
     */
    public function getAttributeName()
    {
        return 'CustomerManagementPendingDsk';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerManagementPendingDsk
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
